//
//  AppDelegate.swift
//  MenuToolDemo
//
//  Created by 5km on 2019/10/22.
//  Copyright © 2019 5km. All rights reserved.
//

import Cocoa
import SwiftUI

@NSApplicationMain
class AppDelegate: NSObject, NSApplicationDelegate {
    
    @IBOutlet weak var menu: NSMenu!
    
    let statusItem = NSStatusBar.system.statusItem(withLength: NSStatusItem.squareLength)
    
    func applicationDidFinishLaunching(_ aNotification: Notification) {
        
        menu.delegate = self
        
        if let button = statusItem.button {
            button.image = NSImage(named: "StatusIcon")
            button.action = #selector(mouseClickHandler)
            button.sendAction(on: [.leftMouseUp, .rightMouseUp])
        }
        
    }
    
    @objc func mouseClickHandler() {
        if let event = NSApp.currentEvent {
            switch event.type {
            case .leftMouseUp:
                // 使用警告窗口示意左键单击
                let alert = NSAlert()
                alert.messageText = "鼠标事件"
                alert.informativeText = "左键单击"
                alert.addButton(withTitle: "关闭")
                alert.window.titlebarAppearsTransparent = true
                alert.runModal()
            default:
                statusItem.menu = menu
                statusItem.button?.performClick(nil)
            }
        }
    }

    @IBAction func quitApp(_ sender: Any) {
        NSApplication.shared.terminate(self)
    }
    
    func applicationWillTerminate(_ aNotification: Notification) {
        // Insert code here to tear down your application
    }

}

extension AppDelegate: NSMenuDelegate {
    // 为了保证按钮的单击事件设置有效，menu要去除
    func menuDidClose(_ menu: NSMenu) {
        statusItem.menu = nil
    }
}
